<?PHP
/**
 * SMF 2.0.X Branch Simple Smileys
 * copyright 2018 ~ GNU LESSER GENERAL PUBLIC LICENSE v3
 * Chen Zhen @ web-develop.ca
 */

if (!defined('SMF'))
	die('<b>Error:</b> Access denied!');

function Simple_Smileys_Paths()
{
	global $boarddir, $modSettings;

	$path = empty($modSettings['smileys_dir']) ? $boarddir . '/Smileys' : $modSettings['smileys_dir'];
	list($files, $paths) = array(array(), array());
	$files = scandir($path);

	foreach ($files as $file)
	{
		if ($file == '.' || $file == '..')
			continue;

		if (is_dir($path . '/' . $file))
			$paths[] = $file;
	}

	return $paths;
}

function Simple_Smileys_Add($path)
{
	db_extend('packages');

	// Add Simple Smileys to the database
	global $boarddir, $modSettings, $smcFunc;

	list($fileArray, $currentFiles, $files, $ids, $lastOrder, $allowed) = array(array(), array(), array(), array(), 0, array('.jpg', '.gif', '.png'));
	$pathname = empty($modSettings['smileys_dir']) ? $boarddir . '/Smileys' : $modSettings['smileys_dir'];
	$pathname .= '/' . $path;
	$files = scandir($pathname);

	$request = $smcFunc['db_query']('', '
		SELECT id_smiley, smiley_order, filename
		FROM {db_prefix}smileys
		ORDER BY smiley_order DESC',
		array()
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$lastOrder = empty($lastOrder) ? $row['smiley_order'] + 1 : $lastOrder;
		$currentFiles[] = $row['filename'];
		$ids[] = $row['id_smiley'];
	}
	$smcFunc['db_free_result']($request);

	$min = max($ids)+1;
	$smcFunc['db_query']('', "ALTER TABLE {db_prefix}smileys AUTO_INCREMENT = {$min}");

	foreach ($files as $file)
	{
		if ($file == '.' || $file == '..' || !in_array(substr(strtolower($file), -4), $allowed) || in_array($file, $currentFiles))
			continue;

		$filepath = $pathname . '/' . $file;
		$pic_type = substr(strtolower($file), -4);
		$filename = substr($file, 0, -4);
		$fileArray[] = array(
			':$' . $filename . '$:',
			$file,
			$filename,
			0,
			$lastOrder,
			0,
		);

		$lastOrder++;
	}

	if (!empty($fileArray))
	{
		$max = $min + count($fileArray)-1;
		$smcFunc['db_insert']('ignore',
			'{db_prefix}smileys',
			array(
				'code' => 'string',
				'filename' => 'string',
				'description' => 'string',
				'smiley_row' => 'int',
				'smiley_order' => 'int',
				'hidden' => 'int'
			),
			$fileArray,
			array('id_smiley')
		);

		if (check_table_exists_simple_smileys('simple_smileys') == false)
		{
			$smcFunc['db_create_table']('{db_prefix}simple_smileys',
				array(
					array(
						'name' => 'pathname',
						'type' => 'varchar',
						'size' => 255,
						'unsigned' => true,
						'null' => false
					),
					array(
						'name' => 'start',
						'type' => 'int',
						'size' => 10,
						'unsigned' => true,
						'null' => false
					),
					array(
						'name' => 'end',
						'type' => 'int',
						'size' => 10,
						'unsigned' => true,
						'null' => false
					),
				),
				array(
					array(
						'type' => 'primary',
						'columns' => array('pathname')
					),
				),
					array(),
			'ignore');
		}

		if (!empty($min) && !empty($max))
		{
			$request = $smcFunc['db_query']('', '
				DELETE FROM {db_prefix}simple_smileys
				WHERE pathname = {string:name}',
				array(
					'name' => $path,
				)
			);

			$smcFunc['db_insert']('insert',
				'{db_prefix}simple_smileys',
				array(
					'pathname' => 'string',
					'start' => 'int',
					'end' => 'int'
				),
				array(
					$path,
					$min,
					$max
				),
				array()
			);
		}
	}
}

function Simple_Smileys_Del($path, $removeDir)
{
	db_extend('packages');

	// Remove Simple Smileys from the database
	global $boarddir, $modSettings, $smcFunc;
	$pathname = empty($modSettings['smileys_dir']) ? $boarddir . '/Smileys' : $modSettings['smileys_dir'];
	$pathname .= '/' . $path;

	list($files, $min, $max) = array(array(), 0, 0);
	$files = scandir($pathname);

	$request = $smcFunc['db_query']('', '
		SELECT pathname, start, end
		FROM {db_prefix}simple_smileys
		WHERE pathname = {string:pathname}
		LIMIT 1',
		array(
			'pathname' => $path,
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$min = $row['start'];
		$max = $row['end'];
	}
	$smcFunc['db_free_result']($request);


	foreach ($files as $file)
	{
		if ($file == '.' || $file == '..')
			continue;

		if (!empty($min) && !empty($max))
		{
			$smcFunc['db_query']('', '
				DELETE FROM {db_prefix}smileys
				WHERE filename = {string:filex}
				AND id_smiley >= {int:start}
				AND id_smiley <= {int:end}',
				array(
					'filex' => $file,
					'start' => $min,
					'end' => $max
				)
			);

			$request = $smcFunc['db_query']('', '
				DELETE FROM {db_prefix}simple_smileys
				WHERE pathname = {string:name}',
				array(
					'name' => $path,
				)
			);
		}
	}

	$request = $smcFunc['db_query']('', '
		SELECT id_smiley
		FROM {db_prefix}smileys
		ORDER BY id_smiley DESC
		LIMIT 1',
		array()
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$id = $row['id_smiley']+1;
	}
	$smcFunc['db_free_result']($request);
	$smcFunc['db_query']('', "ALTER TABLE {db_prefix}smileys AUTO_INCREMENT = {$id}");

	if (!empty($removeDir))
		SimpleSmileysRmdir($pathname);
}

// remove the directory if opted
function SimpleSmileysRmdir($dir)
{
	$objects = scandir($dir);
	foreach ($objects as $object)
	{
		if ($object != '.' && $object != '..')
		{
			if (filetype($dir . '/' . $object) == 'dir')
				SimpleSmileysRmdir($dir . '/' . $object);
			else
				unlink($dir . '/' . $object);
		}
	}

	reset($objects);
	rmdir($dir);
}

function check_table_exists_simple_smileys($table)
{
	global $db_prefix, $smcFunc;

	if ($smcFunc['db_list_tables'](false, $db_prefix . $table))
		return true;

	return false;
}

?>